<?php
/*
Plugin Name: Constant Contact Widget
Plugin URI: http://www.seodenver.com/constant-contact-wordpress-widget/
Description: Adds Constant Contact signup form to your sidebar or content without touching code.
Author: Katz Web Services, Inc.
Version: .162
Author URI: http://www.katzwebservices.com
*/

/*
Copyright 2010 Katz Web Services, Inc.  (email: info@katzwebservices.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

# Version .13 	- Added option to show Constant Contact link
#				- Added Basic, Bubble, and Stylish style options from Constant Contact's default options (don't blame ME!)

# Version .131	- Fixed small coding error with closing input tag
#				- Added wptexturize for widget title

# Version .14	- Added option to not show widget, but use with plugin-like functionality by calling widget_cc()
#				- Added option to define custom default input text toggle
#				- Added method to turn off input text toggle and remove the javascript
#				- Fixed improper <label for=""> code
# Version .141	- Fixed code for Stylish design if javascript was turned off
# Version .142	- Fixed code for CSS-only and Stylish design
# Version .143	- Updated CSS for Stylish design to prevent background of email image from showing through
# Version .144	- Input text toggle should work now
#				- Added option to give widget author credit
#				- Made Constant Contact informational links nofollow
#				- Added option to rename or remove <legend> using the No Style form
# Version .145	- Updated Magpie
# Version .146	- Stylish form now has custom button text
#				- Added custom width option for forms
#				- Improved Stylish form email image layout
# Version .15	- Added option to change size of email input
#				- Added option to hide the <fieldset> in the No Style form
#				- Fixed Internet Explorer issue where adding widget would cause active widgets list to disappear.
#				- Added options to change border and background color in the Basic Style form
# Version .152	- Added custom title to Stylish design
#				- Added custom email input label, and option to turn off label
# Version .153	- Fixed unexpected $end issue on some servers, by changing <? to <?php
# Version .154  - Added #go to submit button in all Styles to add more CSS customization
# Version .155	- Added shortcode functionality
# Version .16	- Added different SafeSubscribe(sm) image options for different background colors
#				- Combined the SafeSubscribe image chooser with Display SafeSubscribe option
#				- Improved <label>s in widget
#				- Improved Stylish email image display
#				- Added a proper Changelog to readme.txt
#				- Fixed widget installation "White Screen" error
# Version .161	- Updated plugin to include GPL license
# Version .162	- Added `function_exists` check to fix reported issue

$kwd_cc_version = .162;

if(!function_exists('cc_widget_init')) {

function cc_widget_init() 
	{
	  global $kwd_cc_version;
	  if ( !function_exists('register_sidebar_widget') ) {
	    return;
	  }

	
	if(!function_exists('cc_default_string')) {
		function cc_default_string($saved,$default)
		  {
		    if ( empty($saved) ) {
		        return __($default,'cc');
		    }
		    else {
		        return $saved;
		    }
		  }
	}
	 
	if(!function_exists('widget_cc')) {
	// Constant Contact Plugin WIDGET
	function widget_cc($args = false) {
			global $kwd_cc_version;
			if($args) { extract($args); };
			
			$options = get_option('widget_cc');
			
			if (!is_array($options)) {
				$options = array(
					'title' => __('Constant Contact', 'constant-contact'), 
					'code' => '1234567654321', 
					'preface' => '', 
					'button' => 'Subscribe', 
					'wrap' => 'p', 
					'show_cc_code' =>'yes', 
					'show_safe_subscribe' =>'yes', 
					'show_widget' => 'yes', 
					'style' =>'1', 
					'initial_value_email' => 'example@subscribe.com', 
					'credit' => 'no', 
					'input_size' => '20', 
					'show_fieldset' => 'yes', 
					'email_label' => 'Email:',
					'safesubscribe' => 'light'
				);
			}
			if(empty($options['safesubscribe'])) { $safesubscribe = 'light'; } else { $safesubscribe = $options['safesubscribe']; }
			if($safesubscribe == 'no') {
				$safe_subscribe_img = '';
				$safe_subscribe_link = '';
			} else {
				$safe_subscribe_img = '<img src="http://katzwebdesign.files.wordpress.com/2009/06/safesubscribe-'.$safesubscribe.'.gif" width="168" height="14" alt="SafeSubscribe with Constant Contact"  style="border:0;padding:0; margin:0;" />';
				$safe_subscribe_link = '<a href="http://snurl.com/as4c4" id="cc_safesubscribe" rel="nofollow">'.$safe_subscribe_img.'</a>';
			}
				
			$inital_value_email = wptexturize(stripslashes($options['initial_value_email']));
			
			$width = false;
			$unit = false;
			$width_style = false;
			if(isset($options['width'])) {
				$width = intval(stripslashes($options['width']));
			}
			if(isset($options['unit'])) {
				$unit = stripslashes($options['unit']);
				if($unit == 'per') {
					$unit = '%';
				} else {
					$unit = 'px';
				}
			}
			if($unit && $width) {
				$width_style = ' width:'.$width.$unit.';';
			}
			
			if(isset($options['input_size'])) {
				$input_size = $options['input_size'];
			} else {
				$input_size = '20';
			}
			
			if(isset($options['show_fieldset']) && $options['show_fieldset'] != 'no') {
				$fieldset = true;
			} else {
				$fieldset = false;
			}
			
			if(isset($options['bg_color']) && !empty($options['bg_color'])) {
				if(substr($options['bg_color'], 0, 1) == '#') {
					$bg_color = strtolower(substr($options['bg_color'], 1));
				} else {
					$bg_color = $options['bg_color'];
				}
			} else {
				$bg_color = 'ffffcc';
			}
			if(isset($options['border_color']) && !empty($options['border_color'])) {
				if(substr($options['border_color'], 0, 1) == '#') {
					$border_color = strtolower(substr($options['border_color'], 1));
				} else {
					$border_color = $options['border_color'];
				}
			} else {
				$border_color = '000000';
			}
			
			if(isset($options['email_label']) && !empty($options['email_label'])) {
				if(strtolower($options['email_label']) == 'none') {
					$email_label = false;
				} else {
					$email_label = $options['email_label'];
				}
			} else {
				$email_label = 'Email:';
			}
			
			// If '0' or 'none', show no initial value JS switching
			if($options['initial_value_email'] == '0' || $options['initial_value_email'] == 'none') { $options['show_initial_value'] = false; } else { $options['show_initial_value'] = true; }
			
			
			$title = wptexturize(cc_default_string(stripslashes($options['title']), 'Sign up for our Newsletter'));
			
		if($options['style'] == 1) { 
			// Basic design (Image at http://img.constantcontact.com/ui/images1/signupbox_form_basicS.gif)
			$pre = '
			<div style="margin:0 auto; padding:3px; background-color:#'.$bg_color.'; border:2px solid #'.$border_color.';'.$width_style.'">
			<div style="text-align:center; font-weight: bold; font-family:Arial; font-size:12px; color:#000000;">'.$title.'</div>';
			
			$form = '<form name="ccoptin" action="http://visitor.constantcontact.com/d.jsp" target="_blank" method="post" style="margin-bottom:2px; text-align:center; border-top:2px solid #'.$border_color.';">
			<!-- Constant Contact Widget by Katz Web Services, Inc. -->
			<input type="hidden" name="m" value="'.$options['code'].'" />
			<input type="hidden" name="p" value="oi" />';
			if($email_label) {
			$form .= '<span style="font-weight: normal; font-family:Arial; font-size:12px; color:#000000;">'.$email_label.'</span>';
			}
			$form .= '<input type="text" name="ea" size="'.$input_size.'" ';
			if($options['show_initial_value']) { 
				$form .= 'value="'.$inital_value_email.'" onfocus="if (this.value == \''.$inital_value_email.'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.$inital_value_email.'\';}"';
			} else {
				$form .= 'value=""';
			}
			$form .= ' style="font-size:10pt; border:1px solid #999999;" />
			<input type="submit" id="cc_go" id="go" value="'.cc_default_string($options['button'],'Subscribe').'" class="submit" style="font-family:Verdana,Geneva,Arial,Helvetica,sans-serif; font-size:10pt;" />
			</form>';
			
			$post = '
			</div>';
			
			$safe = '<div style="text-align:center; margin:0 auto; width:168px; padding-top:5px;">'.$safe_subscribe_link.'</div>';
			
			$link = '<div style="display:block; text-align:center; margin:0 auto; font-family:Arial,Helvetica,sans-serif;font-size:10px;color:#999999;">
			For <a href="http://snurl.com/as4af" rel="nofollow" style="text-decoration:none;font-family:Arial,Helvetica,sans-serif;font-size:10px;color:#999999;" target="_blank">Email Marketing</a> you can trust
			</div>';		
		}
		elseif($options['style'] == 2) { 
			// Bubble design (Image at http://img.constantcontact.com/ui/images1/signupbox_form_bubbleS.gif)
			if(!$width) {
				$width = 170;
			}
			$width2 = $width - 18;
			$pre = '<div style="text-align:center; width:'.$width.$unit.'; margin:0 auto; padding:0;">
			<table width="'.$width.'" border="0" cellspacing="0" cellpadding="0" >
			<tr bgcolor="#006699" valign="top">
			<td width="9" rowspan="2"><img src="http://img.constantcontact.com/ui/images/visitor/tl_brdr2_trans.gif" width="9" height="9" style="border:0; padding:0; margin:0;"></td>
			<td width="'.$width2.'" height="1" bgcolor="#006699"><img src="http://img.constantcontact.com/ui/images/spacer.gif" border="0" width="1" height="1"></td>
			<td width="9" rowspan="2" align="right"><img src="http://img.constantcontact.com/ui/images/visitor/tr_brdr2_trans.gif" width="9" height="9" border="0"></td>
			</tr>
			<tr>
			<td width="'.$width2.'" height="8" bgcolor="#ffffff"><img src="http://img.constantcontact.com/ui/images/spacer.gif" border="0" width="1" height="1"></td>
			</tr>
			<tr>
			<td width="'.$width.'" colspan="3" style="border-left: 1px solid #006699;border-right: 1px solid #006699; background-color:#ffffff;"><div align="center">';
			
			$form = '
			<form name="ccoptin" action="http://visitor.constantcontact.com/d.jsp" target="_blank" method="post" style="margin-bottom:3px;">
			<!-- Constant Contact Widget by Katz Web Services, Inc. -->
			<span style="font-weight: bold; font-family:Arial; font-size:18px; color:#006699;">'.$title.'</span><br />';
			if($email_label) {
			$form .= '<span style="font-weight: normal; font-family:Arial; font-size:10px; color:#000000;">'.$email_label.'</span>';
			}
			$form .= '<input type="text" name="ea" size="'.$input_size.'" ';
			if($options['show_initial_value']) { 
				$form .= 'value="'.$inital_value_email.'" onfocus="if (this.value == \''.$inital_value_email.'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.$inital_value_email.'\';}"';
			} else {
				$form .= 'value=""';
			}
			$form .= ' style="font-family: Arial; font-size:10px; border:1px solid #999999;" />&nbsp;<input type="submit" id="cc_go" id="go" value="'.cc_default_string($options['button'],'Subscribe').'" class="submit"  style="font-family:Arial,Helvetica,sans-serif; font-size:11px;">
			<input type="hidden" name="m" value="'.$options['code'].'" />
			<input type="hidden" name="p" value="oi" />
			</form>
			';
			
			$post = '</div></td>
			</tr>
			<tr bgcolor="#006699" valign="bottom">
			<td rowspan="2"><img src="http://img.constantcontact.com/ui/images/visitor/bl_brdr2_trans.gif" width="9" height="9" border="0" /></td>
			<td width="152" height="8" bgcolor="#ffffff"><img src="http://img.constantcontact.com/ui/images/spacer.gif" border="0" width="1" height="1"></td>
			<td rowspan="2" align="right"><img src="http://img.constantcontact.com/ui/images/visitor/br_brdr2_trans.gif" width="9" height="9" border="0"></td>
			</tr>
			<tr>
			<td width="152" bgcolor="#006699"><img src="http://img.constantcontact.com/ui/images/spacer.gif" border="0" width="1" height="1"></td>
			</tr>
			</table>
			</div>';
			
			$safe = '<div align="center" style="padding-top:5px;">'.$safe_subscribe_link.'</div>';
			
			$link = '<div align="center" style="font-family:Arial,Helvetica,sans-serif;font-size:10px;color:#999999;">
			For <a href="http://snurl.com/as4af" rel="nofollow" style="text-decoration:none;font-family:Arial,Helvetica,sans-serif;font-size:10px;color:#999999;" target="_blank">Email Marketing</a> you can trust
			</div>';		
		}
		elseif($options['style'] == 3) {
			// The 'Stylish' design (Image at http://img.constantcontact.com/ui/images1/signupbox_form_stylishS.gif)
			if(!$width) {
				$width = 160;
			}
			if($title == "Constant Contact") {
				$title = 'Sign up for our Email Newsletter';
			}
			$pre = '<div style="width:'.$width.$unit.'; background-color: #ffffff;text-align:center; margin:0 auto;">';
			
			$form = '<form name="ccoptin" action="http://visitor.constantcontact.com/d.jsp" target="_blank" method="post" style="margin-bottom:3px;"><span style="background-color: #006699; float:right;margin-right:5px;margin-top:3px; display:block; padding:0; width:19px; height:14px; overflow:hidden;"><img src="http://img.constantcontact.com/ui/images1/visitor/email1_trans.gif" alt="Email icon" width="19" height="14" style="border:0; padding:0; margin:0;" /></span>
	<label for="ea" style="font-weight: bold; font-family:Arial; font-size:16px; color:#006699; display:block; padding-bottom:.2em;">'.$title.'</label>
	<input type="text" id="ea" name="ea" size="'.$input_size.'" ';
			if($options['show_initial_value']) { 
				$form .= 'value="'.$inital_value_email.'" onfocus="if (this.value == \''.$inital_value_email.'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.$inital_value_email.'\';}" style="font-size:10pt; border:1px solid #999999; font-family:Verdana,Geneva,Arial,Helvetica,sans-serif; font-size:10px; border:1px solid #999999; color: #666666;"';
			} else {
				$form .= 'value="" style="font-family:Verdana,Geneva,Arial,Helvetica,sans-serif; font-size:10px; border:1px solid #999999; color: #666666;"';
			}
			$form .= ' />
			<input type="submit" id="go"  id="go" name="go" value="'.cc_default_string($options['button'],'Subscribe').'" class="submit"  style="font-family:Verdana,Arial,Helvetica,sans-serif; font-size:10px;">
			<input type="hidden" id="m" name="m" value="'.$options['code'].'" />
			<input type="hidden" id="p" name="p" value="oi" /></form>';
			
			$post = '</div>';
		
			$link = '<div align="center" style="font-family:Arial,Helvetica,sans-serif;font-size:10px;color:#999999;">
	For <a href="http://snurl.com/as4af" rel="nofollow" style="text-decoration:none;font-family:Arial,Helvetica,sans-serif;font-size:10px;color:#999999;" target="_blank">Email Marketing</a> you can trust
	</div>';
			
			$safe = '<div align="center" style="padding-top:5px;">'.$safe_subscribe_link.'</div>';
		
		}
		else {
		// No style
			
			$pre = $before_title."\n".$title."\n".$after_title;
			
			$form = '
			<form name="ccoptin" action="http://visitor.constantcontact.com/d.jsp" target="_blank" method="post">
			<!-- Constant Contact Widget by Katz Web Services, Inc. -->';
			if($options['preface'] != '') {
				$form .= '<'.cc_default_string($options['wrap'],'p').'>'.htmlspecialchars(stripslashes($options['preface'])).'</'.cc_default_string($options['wrap'],'p').'>';
			}
			if($fieldset) {
			$form .= '
			<fieldset>';
			}
			if(htmlspecialchars(stripslashes($options['legend'])) != '') { $form .= '<legend>'.htmlspecialchars(stripslashes($options['legend'])).'</legend>'; };
			if($email_label) {
			$form .= '
			<label for="ea">'.$email_label.'</label>';
			}
			$form .= '
			<input type="text" name="ea" size="'.$input_size.'" ';
			if($options['show_initial_value']) { 
				$form .= 'value="'.$inital_value_email.'" onfocus="if (this.value == \''.$inital_value_email.'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.$inital_value_email.'\';}"';
			} else {
				$form .= 'value=""';
			}
			$form .= ' />
			<button type="submit" class="submit" id="go" name="go">'.cc_default_string($options['button'],'Subscribe').'</button>
			<input type="hidden" id="m" name="m" value="'.$options['code'].'" />
			<input type="hidden" id="p" name="p" value="oi" />';
			if($fieldset) {
			$form .= '
			</fieldset>';
			}
			$form .= '
			</form>'."\n";
			
			$post = '';
			
			$link = '<p>For <a href="http://snurl.com/as4af" rel="external nofollow">Email Marketing</a> you can trust</p>';
			
			$safe = $safe_subscribe_link;
			
			
		}
		
			
		// If you have chosen to show the attribution link, add the link
		if($options['credit'] != 'no') {	
	
			if(!function_exists('kwd_cc_rss_output')){
			function kwd_cc_rss_output($rss = '', $default = '') {
					require_once(ABSPATH . WPINC . '/rss.php');
					if ( !$rss = fetch_rss($rss) )
						return;
					
					$items = 1;
					if ( is_array( $rss->items ) && !empty( $rss->items ) ) {
						$rss->items = array_slice($rss->items, 0, $items);
						foreach ($rss->items as $item ) {
							if ( isset( $item['description'] ) && is_string( $item['description'] ) )
								$summary = $item['description'];
							$desc = str_replace(array("\n", "\r"), ' ', $summary);
							$summary = '';
							return $desc;
						}
					} else {
						return $default;
					}
			} // end kwd_rss_output
			}
			
			if(!function_exists('kwd_cc_attr')) {
				function kwd_cc_attr() { 
					global $post, $kwd_cc_version;// prevents calling before <HTML>
					if($post && !is_admin()) {
						$site = 'http://www.katzwebservices.com/development/attribution.php?site='.htmlentities(substr(get_bloginfo('url'), 7)).'&from=cc_widget&version='.$kwd_cc_version;
						$output = kwd_cc_rss_output($site, $default);
						echo $output;
					}
				}
			}
			
			// If you DON'T want the link to be automatically added to the footer using wp_footer() delete below.
			if(function_exists('add_action') && function_exists('kwd_cc_attr')) { add_action('wp_footer', 'kwd_cc_attr'); }
			// End delete
			
		} else {
			function kwd_cc_footercomment() {
				echo "\n".'<!-- Constant Contact widget by Katz Web Services, Inc. | http://www.katzwebservices.com -->'."\n\n";
			}
			if(function_exists('add_action') && function_exists('kwd_cc_footercomment')) { add_action('wp_footer', 'kwd_cc_footercomment'); }
		} // End Credit
		
		// PUT TOGETHER THE WIDGET
		
		if($options['show_widget'] != 'no') {
			$widget = $before_widget;
		}
		$widget .= $pre;
		$widget .= $form;
		$widget .= $post;
		
		if($options['show_cc_code'] == 'yes' || $options['show_cc_code'] == '') {
			$widget .= $link;
		}
		if($options['show_safesubscribe'] == 'yes' || $options['show_safesubscribe'] == '' && $options['show_safesubscribe'] != 'no' && $options['safesubscribe'] != 'no') {
			$widget .= $safe;
		}
		if($options['show_widget'] != 'no') {
			$widget .= $after_widget;	
		}
		if($options['show_widget'] != 'no') {
			echo $widget;
		} else {
			return $widget;
		}
		
		
	} // end Widget
	} // end if exists
	  
	// Constant Contact Plugin OPTIONS
		function widget_cc_options() {
			global $kwd_cc_version;
			$options = get_option('widget_cc');
			if (!is_array($options)) {
				$options = array('title' => __('Constant Contact', 'constant-contact'), 'code' => '1234567654321', 'preface' => '', 'button' => 'Subscribe', 'wrap' => 'p', 'show_cc_code' =>'yes', 'show_safe_subscribe' =>'yes', 'show_widget' => 'yes', 'style' =>'1', 'initial_value_email' => 'example@subscribe.com', 'legend' => 'Sign Up', 'input_size' => '20', 'email_label' => 'Email:','safesubscribe'=>'light');
			}
			if ($_POST['cc_form_submit']) {
				$options['title']=strip_tags(stripslashes($_POST["cc_form_title"]));
				$options['code']=strip_tags(stripslashes($_POST["cc_form_code"]));
				$options['preface']=strip_tags(stripslashes($_POST["cc_form_preface"]));
				$options['button']=strip_tags(stripslashes($_POST["cc_form_button"]));
				$options['wrap']=strip_tags(stripslashes($_POST["cc_form_wrap"]));
				$options['show_cc_code'] = strip_tags(stripslashes($_POST["cc_show_cc_code"]));
				$options['style'] = strip_tags(stripslashes($_POST["cc_style"]));
				$options['show_safesubscribe'] = strip_tags(stripslashes($_POST["cc_show_safesubscribe"]));
				$options['show_widget'] = strip_tags(stripslashes($_POST["cc_show_widget"]));
				$options['show_fieldset'] = strip_tags(stripslashes($_POST["cc_show_fieldset"]));
				$options['credit'] = strip_tags(stripslashes($_POST["cc_credit"]));
				$options['legend'] = strip_tags(stripslashes($_POST["cc_legend"]));
				$options['bg_color'] = strip_tags(stripslashes($_POST["cc_bg_color"]));
				$options['email_label'] = strip_tags(stripslashes($_POST["cc_email_label"]));
				$options['border_color'] = strip_tags(stripslashes($_POST["cc_border_color"]));
				$options['width'] = strip_tags(stripslashes($_POST["cc_width"]));
				$options['unit'] = strip_tags(stripslashes($_POST["cc_unit"]));
				$options['input_size'] = strip_tags(stripslashes($_POST["cc_input_size"]));
				$options['safesubscribe'] = strip_tags(stripslashes($_POST["cc_safesubscribe"]));
				$options['initial_value_email'] = strip_tags(stripslashes($_POST["cc_initial_value_email"]));
				update_option('widget_cc', $options);
			}
			?> 
			 <div>
				 <label for="cc_form_title">
				  <strong><?php _e('Title:'); ?></strong>
				</label>
				  <input style="width: 100%; margin-bottom:1em;" id="cc_form_title" name="cc_form_title" type="text" value="<?php echo htmlspecialchars(stripslashes($options['title'])); ?>" />
				 <label for="cc_form_code">
				 <strong> <?php _e('Unique Form ID Code:'); ?></strong>
				 </label><br />
				 <strong>* REQUIRED - The form will not work without this properly entered.</strong><br />
				 You can find this code by setting up your Site Visitor Signup form in Constant Contact (Contacts > Site Visitor Signup) . The Unique Form ID Code can be found by looking for <code>&lt;input type=&quot;hidden&quot; name=&quot;m&quot; value=&quot;1234567654321&quot;&gt;</code>, where <code>1234567654321</code> is the code you want to enter below.<br />
				 Don't have Constant Contact? <a href="http://snurl.com/as4af">Try a 60 day free trial</a>, then you can use this widget.<br />
				  <input style="width: 100%;" id="cc_form_code" class="required" name="cc_form_code" type="text" value="<?php echo $options['code']; ?>" />
				  REQUIRED
		
				<br /><br />
				 <label for="cc_form_preface">
				  <strong><?php _e('Additional Information:'); ?></strong>
				  <br />Displayed below the Title
				</label><br />
				  <input style="width: 100%; margin-bottom:1em;" id="cc_form_preface" name="cc_form_preface" type="text" value="<?php echo htmlspecialchars(stripslashes($options['preface'])); ?>" />
				  <label for="cc_form_wrap">
				  <strong><?php _e('Wrap \'Additional Information\' in:'); ?></strong>
				</label>
				  <input style="width: 100%; margin-bottom:1em;" id="cc_form_wrap" name="cc_form_wrap" type="text" value="<?php echo htmlspecialchars(stripslashes($options['wrap'])); ?>" />			
				  <label for="cc_form_button">
				  <strong><?php _e('Button Text:'); ?></strong>
				</label>
				  <input style="width: 100%; margin-bottom:1em;" id="cc_form_button" name="cc_form_button" type="text" value="<?php echo htmlspecialchars(stripslashes($options['button'])); ?>" />
				  <br />
				 <br />
				 <strong><?php _e('Form style:'); ?></strong><br />
	
				  <label for="cc_style_0"style="padding-bottom:.5em;">
				  <input type="radio" id="cc_style_0" name="cc_style" value="0" <?php if(htmlspecialchars(stripslashes($options['style'])) == '0' || htmlspecialchars(stripslashes($options['style'])) == '') { echo 'checked="checked"';}; ?> />
				  <strong>No Style</strong> <br />(Can be styled using CSS. This is also the most valid HTML of the choices.)</label>
				 <br /><br />
				
				
				 <ul>
				 <li>
				 <label for="cc_legend"><strong><?php _e('No Style Only - Legend title:'); ?></strong><br />
				  Leave empty to hide. Otherwise, it will be a form <code>&lt;legend&gt;</code>
				  <input style="width: 100%; margin-bottom:1em;" id="cc_legend" name="cc_legend" type="text" value="<?php echo htmlspecialchars(stripslashes($options['legend'])); ?>" />
				  </label></li>
				  
				<li>
				<ul><li><strong><?php _e('No Style: Show <code>&lt;fieldset&gt;</code>? (A border surrounding the form):'); ?><br /></strong>
				<li><label for="cc_show_fieldset_yes">Show fieldset
				  <input type="radio" id="cc_show_fieldset_yes" name="cc_show_fieldset" value="yes" <?php if(htmlspecialchars(stripslashes($options['show_fieldset'])) != 'no') { echo 'checked="checked"';}; ?> />
				  </label></li>
				  
				<li><label for="cc_show_fieldset_no">Hide fieldset
				 <input type="radio" id="cc_show_fieldset_no" name="cc_show_fieldset" value="no" <?php if(htmlspecialchars(stripslashes($options['show_fieldset'])) == 'no') { echo 'checked="checked"';}; ?> /></label></li></li></ul></li>
				 </ul>
				 
				 <br />
				<label for="cc_style_1">
				  <input type="radio" id="cc_style_1" name="cc_style" value="1" <?php if(htmlspecialchars(stripslashes($options['style'])) == '1') { echo 'checked="checked"';}; ?> />
				  <strong>Basic Design</strong>This is also the most valid HTML of the choices.<br /><img src="http://img.constantcontact.com/ui/images1/signupbox_form_basicS.gif" style="padding-left:1.25em; padding-bottom:.5em;" /></label>
				  <div id="cc_style_1_options">
				 <label for="cc_bg_color"><strong><?php _e('Basic Style Only - Change Background Color:'); ?></strong><br />
				  If you know the <a href="http://en.wikipedia.org/wiki/List_of_colors" target="_blank" title="Go to a Wikipedia article with a list of colors. Opens in new window.">HEX value</a> for the background color you want, enter it here. Ex: <code>F4C2C2</code>.
				  <input style="width: 100%; margin-bottom:1em;" id="cc_bg_color" name="cc_bg_color" type="text" value="<?php echo htmlspecialchars(stripslashes($options['bg_color'])); ?>" />
				  </label>
				   <br /> 
				   
				 <label for="cc_border_color"><strong><?php _e('Basic Style Only - Change Border Color:'); ?></strong><br />
				  If you would like to change the border color, enter the <a href="http://en.wikipedia.org/wiki/List_of_colors" target="_blank" title="Go to a Wikipedia article with a list of colors. Opens in new window.">HEX value</a>.
				  <input style="width: 100%; margin-bottom:1em;" id="cc_border_color" name="cc_border_color" type="text" value="<?php echo htmlspecialchars(stripslashes($options['border_color'])); ?>" />
				  </label>
				<br />
				  <label for="cc_style_2">
				  <input type="radio" id="cc_style_2" name="cc_style" value="2" <?php if(htmlspecialchars(stripslashes($options['style'])) == '2') { echo 'checked="checked"';}; ?> />
				  <strong>Bubble Design</strong><br />ONLY suitable for websites with white background.<br /><img src="http://img.constantcontact.com/ui/images1/signupbox_form_bubbleS.gif" style="padding-left:1.25em; padding-bottom:.5em;" />
				</label>
				<br /><br />
				  <label for="cc_style_3">
				  <input type="radio" id="cc_style_3" name="cc_style" value="3" <?php if(htmlspecialchars(stripslashes($options['style'])) == '3') { echo 'checked="checked"';}; ?> />
				  <strong>Stylish Design</strong> <br /><img src="http://img.constantcontact.com/ui/images1/signupbox_form_stylishS.gif" style="padding-left:1.25em; padding-bottom:.5em;" />
				</label>
				</div>
				<br />
				
				
				<label for="cc_initial_value_email">
				  <strong><?php _e('Email field initial value:'); ?></strong><br />
				  This is shown inside the email address input field and disappears when users click to enter their email address.
				  <br />To turn off this functionality, enter "<code>0</code>" or "<code>none</code>"
				
				  <input style="width: 100%; margin-bottom:1em;" id="cc_initial_value_email" name="cc_initial_value_email" type="text" value="<?php echo htmlspecialchars(stripslashes($options['initial_value_email'])); ?>" /></label>
				
				 <label for="cc_email_label"><strong><?php _e('Email Label:'); ?></strong><br />
				  What would you like the label to be for the email input? To hide, enter <code>none</code>. Otherwise, it will be "Email:"
				
				  <input style="width: 100%; margin-bottom:1em;" id="cc_email_label" name="cc_email_label" type="text" value="<?php echo htmlspecialchars(stripslashes($options['email_label'])); ?>" /></label>
				
				<label for="cc_width"><strong><?php _e('Custom Width'); ?></strong><br />
				 The width was previously hard coded; now you can choose to have the form be any value, in <span title="pixels">px</span> or <span title="percent">%</span>. Examples: <code>200</code> or <code>100</code>. Specify px or % below. <em>Leave blank for default widths</em>.
				 <input style="width: 100%; margin-bottom:1em;" id="cc_width" name="cc_width" type="text" value="<?php echo htmlspecialchars(stripslashes($options['width'])); ?>" /></label>
				 
				 <strong><?php _e('Width in px or %:'); ?></strong><br />
				Is the width in px or %?<br />
				<label for="cc_unit_px">Pixels (<code>px</code>)
				
				  <input type="radio" id="cc_unit_px" name="cc_unit" value="px" <?php if(htmlspecialchars(stripslashes($options['unit'])) == 'px') { echo 'checked="checked"';}; ?> /></label><br />
				<label for="cc_unit_per">Percent <code>%</code>
				 <input type="radio" id="cc_unit_per" name="cc_unit" value="per" <?php if(htmlspecialchars(stripslashes($options['unit'])) == 'per') { echo 'checked="checked"';}; ?> /> </label>
				 
				 <br /><br />
				 
				 <label for="cc_input_size"><strong><?php _e('Size of Email Input:'); ?></strong><br />
				Enter # of characters wide, as a number. Defaults to <code>20</code>.<br />
				<input style="width: 100%; margin-bottom:1em;" id="cc_input_size" name="cc_input_size" type="text" value="<?php echo htmlspecialchars(stripslashes($options['input_size'])); ?>" />
				 </label>
				 <br /><br />
				 
				 <strong><?php _e('Show Constant Contact Link:'); ?></strong><br />
				<label for="cc_show_cc_code_yes">Yes
				
				  <input type="radio" id="cc_show_cc_code_yes" name="cc_show_cc_code" value="yes" <?php if(htmlspecialchars(stripslashes($options['show_cc_code'])) == 'yes' || htmlspecialchars(stripslashes($options['show_cc_code'])) == '') { echo 'checked="checked"';}; ?> /></label>
				<label for="cc_show_cc_code_no">No
				
				  <input type="radio" id="cc_show_cc_code_no" name="cc_show_cc_code" value="no" <?php if(htmlspecialchars(stripslashes($options['show_cc_code'])) == 'no') { echo 'checked="checked"';}; ?> /> 		</label>	 
				 <br /><br />
				 <label><strong>SafeSubscribe</strong></label><br />
				<p>SafeSubscribe logo re-assures potential subscribers that it will be painless to unsubscribe if they choose to. Choose which image will look best with your theme.</p>
		<ul>
		  	<li><label for="safesubscribelight"><input type="radio" value="light" name="cc_safesubscribe" id="safesubscribelight" <?php if(htmlspecialchars(stripslashes($options['safesubscribe'])) == 'light' || htmlspecialchars(stripslashes($options['safesubscribe'])) == '') { echo 'checked="checked"';}; ?> /> <small>Gray</small><br /><img src="http://katzwebdesign.files.wordpress.com/2009/06/safesubscribe-light.gif" alt="SafeSubscribe Light" width="168" height="14" id="safesubscribelightimg" title="Gray"/></label></li>
		  	<li><label for="safesubscribedark"><input type="radio" value="dark" name="cc_safesubscribe" id="safesubscribedark"  <?php if(htmlspecialchars(stripslashes($options['safesubscribe'])) == 'dark') { echo 'checked="checked"';}; ?>/> <small>White</small><br /><img src="http://katzwebdesign.files.wordpress.com/2009/06/safesubscribe-dark.gif" alt="SafeSubscribe Dark" width="168" height="14" id="safesubscribedarkimg" title="White" style="background:black;"/></label></li>
		  	<li><label for="safesubscribeblack"><input type="radio" value="black" name="cc_safesubscribe" id="safesubscribeblack" <?php if(htmlspecialchars(stripslashes($options['safesubscribe'])) == 'black') { echo 'checked="checked"';}; ?>/> <small>Black</small><br /><img src="http://katzwebdesign.files.wordpress.com/2009/06/safesubscribe-black.gif" alt="SafeSubscribe Black" width="168" height="14" id="safesubscribeblackimg" title="Black"  style="background:white;"/></label></li>
		  	<li><label for="safesubscribeno"><input type="radio" value="no" name="cc_safesubscribe" id="safesubscribeno" <?php if(htmlspecialchars(stripslashes($options['safesubscribe'])) == 'no' || htmlspecialchars(stripslashes($options['show_safesubscribe'])) == 'no') { echo 'checked="checked"';}; ?>/> <small>Do Not Display</small></label></li>
		</ul>
				<br />
				
				 <strong><?php _e('Show the Widget:'); ?></strong><br />
				<p>If you want to use the widget code in the PHP and not have it be in the sidebar, select <code>No, Hide Widget</code></p>
				<label for="cc_show_widget_yes">Yes, Show Widget
				
				  <input type="radio" id="cc_show_widget_yes" name="cc_show_widget" value="yes" <?php if(htmlspecialchars(stripslashes($options['show_widget'])) != 'no') { echo 'checked="checked"';}; ?> /></label><br />
				<label for="cc_show_widget_no">No, Hide Widget
				  <input type="radio" id="cc_show_widget_no" name="cc_show_widget" value="no" <?php if(htmlspecialchars(stripslashes($options['show_widget'])) == 'no') { echo 'checked="checked"';}; ?> /> </label>
				  
				  <br /><br />
				 <strong><?php _e('Give Credit Link'); ?></strong><br />
				If you want to give credit to the widget author, this will add a text link to your website's footer. It would be much appreciated, and you can always turn it off.
				<br />
				<label for="cc_credit_yes">Yes, Give Credit
				
				  <input type="radio" id="cc_credit_yes" name="cc_credit" value="yes" <?php if(htmlspecialchars(stripslashes($options['credit'])) != 'no') { echo 'checked="checked"';}; ?> />
				  </label>
				  <br />
				<label for="cc_credit_no">No, Don't Give Credit
				
				  <input type="radio" id="cc_credit_no" name="cc_credit" value="no" <?php if(htmlspecialchars(stripslashes($options['credit'])) == 'no') { echo 'checked="checked"';}; ?> /> 
				</label> 
				 <input type="hidden" name="cc_form_submit" value="Submit" />
				 
				 </div>
			
	<?php		} // end widget_cc_options()
	
		register_sidebar_widget(array('Constant Contact', 'constant-contact'), 'widget_cc');
		register_widget_control(array('Constant Contact', 'constant-contact'), 'widget_cc_options');
	
		function kwd_cc_shortcode() {
			global $post, $kwd_cc_version;
			if(!is_admin()) { return widget_cc(); }
		}
		add_shortcode('constantcontact', 'kwd_cc_shortcode');
		add_shortcode('ConstantContact', 'kwd_cc_shortcode');
	
	
} // end cc_widget_init
}
add_action('widgets_init', 'cc_widget_init');


?>